package practice_tdd;

import java.util.HashMap;

public class Bank {
	private HashMap<Pair, Integer> rates = new HashMap<Pair, Integer>();

	/**
	 * 축약
	 * 
	 * @param source
	 * @param to
	 * @return
	 */
	Money reduce(Expression source, String to) {
		return source.reduce(this, to);
	}

	/**
	 * 맵에서 환율을 가져옴
	 * 
	 * @param from
	 * @param to
	 * @return
	 */
	int getRate(String from, String to) {
		if (from.equals(to))
			return 1; // 동일한 통화의 환율은 1이다

		Integer rate = (Integer)rates.get(new Pair(from, to));
		return rate.intValue();
	}

	/**
	 * 환율 추가 ex) USD -> CHF : 2
	 * 
	 * @param from
	 * @param to
	 * @param rate
	 */
	void addRate(String from, String to, int rate) {
		rates.put(new Pair(from, to), new Integer(rate));
	}
}
