package practice_tdd;

public class Sum implements Expression {

	Expression augend;
	Expression addend;

	/**
	 * 피가산수와 가산수 설정
	 * 
	 * @param augend
	 * @param addend
	 */
	public Sum(Expression augend, Expression addend) {
		this.augend = augend;
		this.addend = addend;
	}

	/**
	 * {@inheritDoc}
	 */
	public Money reduce(Bank bank, String to) {
		int amount = augend.reduce(bank, to).amount + addend.reduce(bank, to).amount;
		return new Money(amount, to);
	}

	/**
	 * {@inheritDoc}
	 */
	public Expression plus(Expression addend) {
		return new Sum(this, addend);
	}

	/**
	 * {@inheritDoc}
	 */
	public Expression times(int multiplier) {
		return new Sum(augend.times(multiplier), addend.times(multiplier));
	}

}
